<template>
	<div class="store">
		<v-dialog v-model="dialog" width="500">
			<v-card>
				<v-card-title class="text-h5 grey lighten-2">
					Review order
				</v-card-title>

				<v-card-text>
					You are about to order:
					<v-row>
						<v-col class="item" v-for="(amount, color) in order" v-bind:key="color">
							<chip-counter showCounter v-bind="{color, amount}"></chip-counter>
						</v-col>
					</v-row>

				</v-card-text>

				<v-divider></v-divider>

				<v-card-actions>
					<v-spacer></v-spacer>
					<v-btn color="success" text @click="placeOrder()">
						<v-icon left>fa-cart-plus</v-icon>Confirm order
					</v-btn>
					<v-btn color="error" text @click="dialog = false">
						<v-icon left>mdi-arrow-left</v-icon>Nevermind
					</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>
		
		<div>
			<v-card elevation="0" class="mx-auto" max-width="90%">
				<v-row justify="center" :style="{ margin: '50px 0px 15px 0' }">
					<v-col v-for="c in colors" v-bind:key="c">
						<ChipCard
							:color="c"
							@amt-changed="amountChanged($event)" />
					</v-col>
				</v-row>
				<v-btn
					class="order-btn"
					color="success"
					large
					block
					@click="reviewOrder()">
					<v-icon size="1.8em" left>fa-cart-plus</v-icon>
					<span>Place order</span>
				</v-btn>
			</v-card>
		</div>
		<v-snackbar v-model="success" bottom right color="success">
			Order placed!
		</v-snackbar>
		<v-snackbar v-model="emptyorder" bottom right color="error">
			You have to order something!
		</v-snackbar>
		<v-snackbar v-model="fullorder" bottom right color="error">
			You can't order more than 20 chips!
		</v-snackbar>
	</div>
</template>

<style scoped>
.order-btn >>> .v-btn__content {
	display: flex;
	gap: 10px;
}

.order-btn {
	font-size: 1em;
}

.theme--light.v-divider {
	border-color: #24325e5f;
	height: 275px;
}
</style>

<script>
import ChipCounter from '@/components/ChipCounter.vue';
import ChipCard from "@/components/ChipCard";
import { colors } from '@/model';
import _ from "lodash";
import { httpPost } from '@/utils/connection';

export default {
	components: { ChipCard, ChipCounter },
	data: () => ({
		colors: colors.map(_.capitalize),
		order: {},
		success: false,
		dialog: false,
		emptyorder: false,
		fullorder: false
	}),
	methods: {
		amountChanged: function({color, amt}) {
			if (amt == 0) delete this.order[color];
			else this.order[color] = amt;
		},
		reviewOrder: async function () {
			let totalAmount = _.sum(Object.values(this.order));
			if (totalAmount <= 0)
				this.emptyorder = true;
			else if (totalAmount > 20)
				this.fullorder = true;
			else
				this.dialog = true;
		},
		placeOrder: async function () {
			this.$emit("order-processing", this.order);
			var orderItems = [];
			for (const [key, value] of Object.entries(this.order)) {
				orderItems.push({ color: key, amount: value });
			}

			var response = await httpPost(process.env.VUE_APP_API_URL + "/orders", {
				orderItems, address: "asd"
			});

			if (response) {
				this.dialog = false;
				this.$router.push("/orders");
				this.success = true;
			}
		},
	},
};
</script>